class SBProjDecalSpawner expands Info;

var class<Decal> DecalClass;

struct ReplicatedVector
{
	var float X, Y, Z;
};

var ReplicatedVector SourceLocation;
var rotator SourceRotation;
var ReplicatedVector InitialDir;

replication
{
	reliable if (Role == ROLE_Authority)
		DecalClass,
		SourceLocation,
		SourceRotation,
		InitialDir;
}

function PostBeginPlay()
{
	SourceLocation = ConvertToReplicatedVector(Location);
	SourceRotation = Rotation;
}

function SetInitialDir(vector Dir)
{
	InitialDir = ConvertToReplicatedVector(Dir);
}

simulated function Tick(float DeltaTime)
{
	local Decal d;
	if (Level.NetMode != NM_DedicatedServer && DecalClass != none)
	{
		d = Spawn(DecalClass, Owner,, ConvertReplicatedVector(SourceLocation), SourceRotation);
		if (d != none)
		{
			d.RemoteRole = ROLE_None;
			if (VSize(ConvertReplicatedVector(InitialDir)) > 0)
				DirectionalAttach(d, ConvertReplicatedVector(InitialDir), vector(SourceRotation));
		}
	}
	Disable('Tick');
}

static function DirectionalAttach(Decal D, vector Dir, vector Norm)
{
	D.SetRotation(rotator(Norm));
	if (D.AttachDecal(100, Dir) == none)
		D.Destroy();
}

static function ReplicatedVector ConvertToReplicatedVector(vector pos)
{
	local ReplicatedVector result;
	result.X = pos.X;
	result.Y = pos.Y;
	result.Z = pos.Z;
	return result;
}

static function vector ConvertReplicatedVector(ReplicatedVector pos)
{
	local vector result;
	result.X = pos.X;
	result.Y = pos.Y;
	result.Z = pos.Z;
	return result;
}

defaultproperties
{
				RemoteRole=ROLE_SimulatedProxy
				LifeSpan=1.000000
				bAlwaysRelevant=True
}
